//
//  LAActionTemplate.h
//  LAAdditions
//
//  Created by Cyril Anger on 15/04/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LATemplate.h>
#import <LAAdditions/LARule.h>

@interface LAActionTemplate : LATemplate

- (LAAction *)createActionInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;
- (void)applyAction:(LAAction *)action toObject:(id)object;

@end

@interface LAKeyPathActionTemplate : LAActionTemplate

@property (strong, nonatomic, readonly) NSString *keyPath;

- (id)initWithName:(NSString *)name keyPath:(NSString *)keyPath;

@end

@interface LASimpleActionTemplate : LAKeyPathActionTemplate

@property (strong, nonatomic, readonly) NSArray *settableKeyPaths;

+ (NSString *)parameterEntity;

- (id)initWithName:(NSString *)name keyPath:(NSString *)keyPath settableKeyPaths:(NSArray *)settableKeyPaths;
- (id)createWidgetForObject:(id)object;
- (void)updateWidget:(id)widget forObject:(id)object;

@end

@interface LABooleanActionTemplate : LASimpleActionTemplate

@end

@interface LAListActionTemplate : LASimpleActionTemplate

@end

@interface LAStringActionTemplate : LASimpleActionTemplate

@end

@interface LADateActionTemplate : LAStringActionTemplate

@end

@interface LANumberActionTemplate : LAStringActionTemplate

@end

@interface LAPercentageActionTemplate : LANumberActionTemplate

@end

@interface LAColorActionTemplate : LASimpleActionTemplate

@end

@interface LAStringReplacementActionTemplate : LAKeyPathActionTemplate

+ (NSArray *)types;

@end

@interface LASwapActionTemplate : LAActionTemplate

@property (strong, nonatomic, readonly) NSArray *keyPathsGroups;

- (id)initWithName:(NSString *)name keyPathsGroups:(NSArray *)keyPathsGroups;

@end
