//
//  LAAppDelegate.h
//  LAAdditions
//
//  Created by Cyril Anger on 06/10/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString *LAUserInterfaceSizeDidChangeNotification;

@interface LAAppDelegate : NSObject <NSApplicationDelegate, NSWindowDelegate, NSToolbarDelegate>

@property (nonatomic, readonly) NSInteger numberOfMinutesInBackground;
@property (nonatomic) NSInteger userInterfaceSize;
@property (nonatomic, readonly) NSArray *preferencesPanes;

- (void)initializeDropboxWithAppKey:(NSString *)appKey secret:(NSString *)secret;
- (NSDictionary *)defaultsForUserInterfaceSize:(NSInteger)userInterfaceSize;
- (NSView *)viewForPreferencesPane:(NSString *)name;
- (void)selectPreferencesPane:(NSString *)name display:(BOOL)display;
- (void)checkForUpdatesAndNotify:(BOOL)notify;

- (IBAction)checkForUpdates:(id)sender;
- (IBAction)showWelcomeWindow:(id)sender;
- (IBAction)closeWelcomeWindow:(id)sender;
- (IBAction)showPreferencesWindow:(id)sender;
- (IBAction)showHelp:(id)sender;

@end
