//
//  LAFileManagerAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 19/01/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

extern NSString *LAFileManagerErrorDomain;

typedef enum {
	LAFileManagerErrorNone = 0,
	LAFileManagerErrorZipFailed,
	LAFileManagerErrorUnzipFailed
} LAFileManagerErrorCode;

@interface NSFileManager (LAFileManagerAdditions)

- (NSString *)validPathForCreatingNewFileAtPath:(NSString *)path;
- (NSURL *)validURLForCreatingNewFileAtURL:(NSURL *)URL;
#if !TARGET_OS_IPHONE
- (void)accessFileAtPath:(NSString *)path message:(NSString *)message successHandler:(void (^)(void))successHandler failureHandler:(void (^)(void))failureHandler;
- (float)fileSizeAtPath:(NSString *)path;
- (NSData *)aliasDataForPath:(NSString *)path;
- (NSString *)pathForAliasData:(NSData *)aliasData;
#endif
- (BOOL)zipFiles:(NSArray *)files toPath:(NSString *)path withPassword:(NSString *)password comment:(NSString *)comment error:(NSError * __autoreleasing *)error;
- (NSArray *)unzipFileAtPath:(NSString *)path inDirectory:(NSString *)directory withPassword:(NSString *)password error:(NSError * __autoreleasing *)error;
- (NSString *)commentOfZipFileAtPath:(NSString *)path withPassword:(NSString *)password error:(NSError * __autoreleasing *)error;
- (NSString *)unzipDocumentWithExtension:(NSString *)extension fromFileAtPath:(NSString *)path error:(NSError * __autoreleasing *)error;

@end
