//
//  LALegacy.h
//  LAAdditions
//
//  Created by Cyril Anger on 14/11/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

@class ANGObjectsManager;

@interface ANGObject : NSObject <NSCoding>

@property (weak, nonatomic) ANGObjectsManager *manager;
@property (strong, nonatomic) NSString *uniqueID;
@property (nonatomic, readonly) BOOL isLeaf;

- (id)initWithManager:(ANGObjectsManager *)manager;

@end

@interface ANGObjectReference : NSObject <NSCoding>

@property (strong, nonatomic) NSString *uniqueID;

+ (ANGObjectReference *)referenceToObject:(ANGObject *)object;

@end

@interface ANGKeyedArchiver : NSKeyedArchiver

@property (nonatomic) BOOL encodeByReference;

@end

@interface ANGKeyedUnarchiver : NSKeyedUnarchiver

@property (weak, nonatomic) ANGObjectsManager *manager;
@property (strong, nonatomic) NSString *password;

@end

@interface ANGObjectsManager : ANGObject

@property (strong, nonatomic) NSString *version;
@property (strong, nonatomic) NSString *password;
@property (nonatomic) BOOL usesEncryption;
@property (nonatomic) BOOL failedDecryption;
@property (strong, nonatomic) NSData *originalData;
@property (strong, nonatomic) NSMapTable *map;
@property (strong, nonatomic) NSMutableDictionary *truthDatabase;

+ (NSString *)classVersion;
+ (NSData *)archivedDataWithRootObject:(id)object encodeByReference:(BOOL)encodeByReference;
+ (void)configureKeyedArchiver:(ANGKeyedArchiver *)archiver;
+ (id)unarchiveObjectWithData:(NSData *)data manager:(ANGObjectsManager *)manager password:(NSString *)password;
+ (void)configureKeyedUnarchiver:(ANGKeyedUnarchiver *)unarchiver;
+ (id)managerWithContentsOfFile:(NSString *)file password:(NSString *)password;
+ (id)managerWithData:(NSData *)data password:(NSString *)password;

- (BOOL)writeToFile:(NSString *)file;
- (NSData *)data;
- (NSData *)unencryptedData;
- (id)decryptObject:(NSData *)data;
- (NSData *)encryptObject:(id)object;

@end

@interface ANGLObjectsManager : NSObject <NSCoding>

@property (strong, nonatomic) NSMutableArray *objects;

@end
