//
//  LALibrary.h
//  LAAdditions
//
//  Created by Cyril Anger on 13/12/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LAManagedObject.h>
#import <LAAdditions/LAImageAdditions.h>
#import <LAAdditions/LAManagedObjectContextOperation.h>

@interface LALibrary : LAManagedObject

@property (strong, nonatomic, readonly) NSOperationQueue *queue;
@property (readonly) NSArray *keywords;
@property (readonly) LAImage *thumbnail;
@property (readonly) LAImage *preview;

- (LAManagedObjectContextOperation *)addOperationWithBlock:(LAManagedObjectContextOperationBlock)block;

@end

@interface NSManagedObjectContext (LALibraryAdditions)

@property (readonly) LALibrary *library;

- (void)resetLibrary;

@end

@interface LALibraryObject : LAManagedObject

@property (getter = isLeaf, nonatomic, readonly) BOOL leaf;
@property (strong, nonatomic) NSString *name;
@property (readonly) LAImage *defaultIcon;
@property (strong, nonatomic) LAImage *icon;
@property (strong, nonatomic) NSData *iconData;
@property (strong, nonatomic, readonly) LAImage *roundedIcon;
@property (strong, nonatomic) NSNumber *hidden;
@property (nonatomic) BOOL hiddenValue;

@end
