//
//  LAManagedObject.h
//  LAAdditions
//
//  Created by Cyril Anger on 03/03/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LASynchronizedObject.h>

@interface LAManagedObject : NSManagedObject <LASynchronizedObject>

@property (strong, nonatomic) NSString *ID;
@property (strong, nonatomic) NSDate *lastModificationDate;
@property (getter = isBeingImported, nonatomic, readonly) BOOL beingImported;

+ (id)insertNewObjectForEntityForName:(NSString *)entityName inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;
+ (id)insertNewObjectWithDictionaryRepresentation:(NSDictionary *)dictionaryRepresentation inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;
+ (void)addRawAccessorsForKey:(NSString *)key;
+ (void)fixOrderedSetAccessorsForKey:(NSString *)key;

- (void)setDefaultValues;
- (id)duplicateInContext:(NSManagedObjectContext *)managedObjectContext;
- (NSArray *)importInContext:(NSManagedObjectContext *)managedObjectContext withRequestsMap:(LAObjectsRequestMap *)requestsMap;

@end

@interface LADeletedManagedObject : NSManagedObject

@property (strong, nonatomic) NSString *ID;
@property (strong, nonatomic) NSDate *date;

@end
