//
//  LAManagedObjectContextSynchronizationSession.h
//  LAAdditions
//
//  Created by Cyril Anger on 09/11/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LASynchronizedObject.h>

@interface LAManagedObjectContextSynchronizationSession : NSObject

@property (strong, nonatomic) NSManagedObjectContext *managedObjectContext;
@property (strong, nonatomic) NSManagedObjectContext *otherManagedObjectContext;
@property (strong, nonatomic) NSURL *otherManagedObjectContextURL;
@property (strong, nonatomic) LAImage *otherIcon;
@property (strong, nonatomic, readonly) LAObjectsRequestMap *synchronizingObjects;
@property (strong, nonatomic, readonly) LAObjectsRequestMap *synchronizingOtherObjects;
@property (strong, readonly) NSArray *changes;
@property (nonatomic) NSUInteger progress;
@property (nonatomic) NSUInteger maxProgress;
@property (getter = isCanceled, readonly) BOOL canceled;
@property (copy, nonatomic) void (^completionHandler)(BOOL canceled);

+ (NSURL *)tempDirectory;

- (void)createOtherManagedObjectContext;
- (void)prepareStep1;
- (void)performStep1;
- (void)finalizeStep1;
- (void)prepareStep2;
- (void)performStep2;
- (void)finalizeStep2;
- (void)cancel;

@end
