//
//  LAObject.h
//  LAAdditions
//
//  Created by Cyril Anger on 03/08/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol LAObject <NSObject>

@required

@property (strong, nonatomic, readonly) NSString *ID;

@optional

@property (weak) NSDictionary *dictionaryRepresentation;

+ (NSArray *)keyPathsToBeCopied;

- (void)delete;
- (id)duplicate;

@end

@interface LAObject : NSObject <LAObject, NSCoding>

@property (strong, nonatomic) NSString *ID;

+ (id)objectWithDictionaryRepresentation:(NSDictionary *)dictionaryRepresentation;

@end

typedef id (^LAMasterObjectResultsBlock)(NSArray *objects, NSArray *results);

@interface LAMasterObject : NSObject <LAObject>

@property (strong, nonatomic) NSArray *objects;

- (id)initWithObjects:(NSArray *)objects;
- (BOOL)duplicatesArgumentForKey:(NSString *)key;
- (void)setDuplicatesArgument:(BOOL)duplicatesArgument forKey:(NSString *)key;
- (void)setResultsBlocks:(LAMasterObjectResultsBlock)resultsBlock forKey:(NSString *)key;
- (BOOL)cachesResultForKey:(NSString *)key;
- (void)setCachesResult:(BOOL)cachesResult forKey:(NSString *)key;

@end
