//
//  LAObjectAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 21/12/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

extern void RunAfterDelay(NSTimeInterval delay, void (^block)(void));
extern void RunOnThread(NSThread *thread, BOOL waitUntilDone, void (^block)(void));
extern void SwizzleMethod(Class class, SEL selector, SEL newSelector, id block);
extern void SwizzleClassMethod(Class class, SEL selector, SEL newSelector, id block);

@interface NSObject (LAObjectAdditions)

+ (void)createAccessorsForKey:(NSString *)key attributeType:(NSAttributeType)attributeType;
+ (void)createMutableArrayAccessorsForKey:(NSString *)key;
+ (NSString *)keyForSelector:(SEL)selector;

- (void)notifyChangeValueForKey:(NSString *)key;
- (id)validValue:(id)value forKeyPath:(NSString *)keyPath;
- (void)setValidValue:(id)value forKeyPath:(NSString *)keyPath;
- (NSString *)validUniqueValue:(NSString *)value forKeyPath:(NSString *)keyPath withLibraryKeyPath:(NSString *)libraryKeyPath parentKeyPath:(NSString *)parentKeyPath childrenKeyPath:(NSString *)childrenKeyPath;
- (NSString *)validUniqueValue:(NSString *)value forKeyPath:(NSString *)keyPath withLibraryKeyPath:(NSString *)libraryKeyPath parentKeyPath:(NSString *)parentKeyPath childrenKeyPath:(NSString *)childrenKeyPath format:(NSString *)format pattern:(NSString *)pattern;
- (void)perform;

@end
