//
//  LAParameter.h
//  LAAdditions
//
//  Created by Cyril Anger on 01/10/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAManagedObject.h>
#import <LAAdditions/LADuration.h>
#import <LAAdditions/LAColorAdditions.h>

@class LAComparisonCondition, LAAction;

@interface LAParameter : LAManagedObject

@property (strong, nonatomic) LAComparisonCondition *condition;
@property (strong, nonatomic) LAAction *action1;
@property (strong, nonatomic) LAAction *action2;
@property (strong, nonatomic) LAAction *action3;
@property (strong, nonatomic) LAAction *action4;
@property (strong, nonatomic) LAAction *action5;
@property (readonly) LAManagedObject *unifiedParent;
@property (strong) id value;

+ (NSArray *)unifiedParentKeyPaths;

@end

@interface LAStringParameter : LAParameter

@property (strong, nonatomic) NSString *string;

@end

@interface LADateParameter : LAParameter

+ (NSArray *)types;
+ (NSArray *)operators;

@property (strong, nonatomic) NSString *type;
@property (strong, nonatomic) NSDate *date;
@property (strong, nonatomic) NSString *timeZoneName;
@property (strong, nonatomic) NSString *operator;
@property (strong, nonatomic) LADuration *duration;

@end

@interface LANumberParameter : LAParameter

@property (strong, nonatomic) NSDecimalNumber *number;

@end

@interface LAColorParameter : LAParameter

@property (strong, nonatomic) LAColor *color;
@property (strong, nonatomic) NSString *colorData;

@end

@interface LAObjectParameter : LAParameter

@property (strong, nonatomic) id object;

@end
