//
//  LATreeController.h
//  LAAdditions
//
//  Created by Cyril Anger on 28/02/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAViewController.h>
#import <LAAdditions/LATreeNode.h>
#import <LAAdditions/LATreeNodesDataSource.h>
#import <LAAdditions/LAOutlineView.h>

@interface LATreeController : LAViewController <NSOutlineViewDataSource, NSOutlineViewDelegate>

@property (nonatomic) BOOL usesClassicDrag;
@property (strong, nonatomic, readonly) LATreeNode *rootNode;
@property (weak, nonatomic) LATreeNodesDataSource *selectedDataSource;

@property (weak, nonatomic) IBOutlet LAOutlineView *treeView;

- (void)loadSections;
- (void)createSections;
- (LATreeNode *)addSectionNamed:(NSString *)name;
- (LATreeNode *)addDataSourceSection:(LATreeNodesDataSource *)dataSource;
- (void)removeSectionNamed:(NSString *)name;
- (void)setSectionsAsDefaultExpandedItems;
- (void)registerDraggedTypes;
- (LATableCellView *)cellForComputingRowHeightWithIdentifier:(NSString *)identifier;

@end

@interface LASingleDataSourceTreeController : LATreeController

@property (strong, nonatomic) IBOutlet LATreeNodesDataSource *dataSource;

@end
