//
//  LAManagedObjectContextAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 05/07/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAManagedObject.h>

extern NSString *LAManagedObjectContextWillTearDownNotification;
extern NSString *LAManagedObjectContextDidTearDownNotification;

@interface NSManagedObjectContext (LAManagedObjectContextAdditions)

@property (assign, nonatomic) id document;
@property (getter = isEditable, readonly) BOOL editable;
@property (getter = isMainContext, readonly) BOOL mainContext;
@property (getter = isMergingChangesFromChildContext, nonatomic, readonly) BOOL mergingChangesFromChildContext;
@property (readonly) LAObjectsRequestMap *synchronizingObjects;

+ (NSManagedObjectContext *)contextForSQLiteStoreAtURL:(NSURL *)URL withConcurrencyType:(NSManagedObjectContextConcurrencyType)concurrencyType error:(NSError * __autoreleasing *)error;

- (id)localObject:(NSManagedObject *)object;
- (NSArray *)localObjects:(NSArray *)objects;
- (NSArray *)executeFetchRequestFromTemplateWithName:(NSString *)name substitutionVariables:(NSDictionary *)substitutionVariables;
- (id)resultOfFunction:(NSString *)function onKeyPath:(NSString *)keyPath ofEntity:(NSString *)entity withPredicate:(NSPredicate *)predicate;
- (id)minimumValueForKeyPath:(NSString *)keyPath ofEntity:(NSString *)entity withPredicate:(NSPredicate *)predicate;
- (id)maximumValueForKeyPath:(NSString *)keyPath ofEntity:(NSString *)entity withPredicate:(NSPredicate *)predicate;
- (void)addDeletedObject:(LAManagedObject *)object;
- (BOOL)isObjectDeleted:(NSString *)ID;
- (void)cleanDeletedObjects;
- (void)postTearDownNotification;

@end
